Attribute VB_Name = "MacrosPourVentura"
Sub PutThinSpace()
'//////////////
'Put thin space codes to act as fine space
'//////////////
Dim Texte$, TexteChang$
    ReplaceWith ":", "<|>:", 4
    ReplaceWith ";", "<|>;", 4
    ReplaceWith "!", "<|>!", 4
    ReplaceWith "?", "<|>?", 4
    ReplaceWith "", "<|>", 4
    ReplaceWith "", "<|>", 4
End Sub
Sub PutFineSpace()
'//////////////
'Put thin space codes to act as fine space
'//////////////
Dim Texte$, TexteChang$
    ReplaceWith ":", "<P4><|><P255>:", 4
    ReplaceWith ";", "<P4><|><P255>;", 4
    ReplaceWith "!", "<P4><|><P255>!", 4
    ReplaceWith "?", "<P4><|><P255>?", 4
    ReplaceWith "", "<P4><|><P255>", 4
    ReplaceWith "", "<P4><|><P255>", 4
End Sub


Sub InSmallCaps()
'//////////////
'Put around an already highlighted text the Ventura markup for SMALL CAPS
'//////////////
Dim Texte$, TexteChang$
    Texte$ = Selection.Text
    TexteChang$ = "<SA>" & Texte$ & "<D>"
    ReplaceWith Texte$, TexteChang$, 4
    ReplaceWith "(<SA>", "<SA>(", 4
    ReplaceWith "<D>)", ")<D>", 4
    
End Sub
Sub PutInNormalView()
    If ActiveWindow.View.SplitSpecial = wdPaneNone Then
        ActiveWindow.ActivePane.View.Type = wdNormalView
    Else
        ActiveWindow.View.Type = wdNormalView
    End If
        
    If ActiveWindow.ActivePane.View.Type = wdPrintView Or ActiveWindow. _
        ActivePane.View.Type = wdWebView Or ActiveWindow.ActivePane.View.Type = _
        wdPrintPreview Then
        ActiveWindow.View.SeekView = wdSeekMainDocument
    End If
End Sub
Sub VersionVentura()
Const VenturaVersion As String = "@Z_STYLE70 = " & vbCr
Dim TestRg As Range
'//////////////
'Places the string @Z_STYLE70 = at the beginning. Check if the string already exists
'//////////////
    Selection.HomeKey Unit:=wdStory
    Set TestRg = ActiveDocument.Paragraphs(1).Range
    
    If TestRg.Text <> VenturaVersion Then
        TestRg.InsertBefore VenturaVersion
    End If
       
End Sub
Sub ExtractTables()
'//////////////
'This macro extracts tables to another document.
'//////////////

    'Save a reference to the original document
    Set FirstDoc = ActiveDocument
    'Create new doc where to put the tables
    Set SecondDoc = Documents.Add(DocumentType:= _
        wdNewBlankDocument)
        
    'Process tables
    For Each MyTable In FirstDoc.Tables
        I = I + 1
        TableNumber = "Table__" & Format(I, "0000")

        'Set range to table text
        Set TableRg = MyTable.Range

        'paste contents of table at end of new doc
        Set PasteRg = SecondDoc.Range   'start with whole doc,
        PasteRg.Collapse wdCollapseEnd  'then collapse to end
        PasteRg.InsertParagraphBefore
        PasteRg.InsertBefore _
            "**********" & TableNumber & "********"
        PasteRg.InsertParagraphBefore
        Set PasteRg = SecondDoc.Range   'start with whole doc,
        PasteRg.Collapse wdCollapseEnd  'then collapse to end
        PasteRg.FormattedText = TableRg.FormattedText
        
        'In the main doc, Table with reference
        Set TableRg = MyTable.Range  'move range to table
        TableRg.Collapse wdCollapseEnd 'move off it to the right
        TableRg.InsertBefore _
            "**********Insert " & TableNumber & " here!********"
        TableRg.InsertParagraphAfter
        MyTable.Delete
    Next MyTable


End Sub
Sub MiscSearches()
    
    '//////////////
    'Replaces Underlined with Italic
    With Selection.Find
       .Wrap = wdFindContinue
       .ClearFormatting
       .Text = ""
       .Font.Underline = True
       With Selection.Find.Replacement
        .ClearFormatting
        .Text = ""
        .Font.Underline = False
        .Font.Italic = True
       End With
    .Execute Replace:=wdReplaceAll
    End With
    '//////////////
    'Other replacements. See ReplaceWith subroutine for explanation
    ReplaceWith "( ", "(", 0  'removes extra space after (
    ReplaceWith " )", ")", 0  'removes extra space before )
    ReplaceWith "...", "", 0 'replace ... with 
End Sub

Sub GeneralCleaning()
    Dim Plage As Range, Quoi As Long
    PutInNormalView
    DoubleReturns 'Double returns (see subroutine)
        
        'Search that includes every "story" of the Word Document
    For Each Plage In ActiveDocument.StoryRanges
        'Activate the story (called Plage. "Quoi" is the iterate number)
        Quoi = Plage.StoryType
        Set MyRange = ActiveDocument.StoryRanges(Quoi)
        MyRange.Select
        
        'Place cursor at the end of the Selection, this to avoid selecting the footnote reference
        Selection.Collapse (wdCollapseEnd)
        'Global Searches. See each subroutines for explanation
        Remplacer_OE
        Remplacer_Espaces
        ReplaceNumbers
        PutSuperscript
        MiscSearches
    Next Plage
    ActiveDocument.Paragraphs.Format.Reset
    ActiveWindow.Panes(1).Activate
    Selection.HomeKey Unit:=wdStory
End Sub
Sub RemoveFonts()
Dim Quoi As Long, UneNote As Footnote, fnumro As Long, Plage As Range, Test As String

        'S'assure qu'aucun appel de note est en exposant
        
    ActiveDocument.Styles("Footnote Reference").BaseStyle = _
        "Default Paragraph Font"
    With ActiveDocument.Styles("Footnote Reference").Font
        .Superscript = False
        .Subscript = False
    End With
    Selection.Style = ActiveDocument.Styles("Footnote Reference")
    
        'Search that includes every "story" of the Word Document
    For Each Plage In ActiveDocument.StoryRanges
            'Activate the story (called Plage. "Quoi" is the iterate number)
        Quoi = Plage.StoryType
        If Quoi = 1 Then VersionVentura
        Set MyRange = ActiveDocument.StoryRanges(Quoi)
        MyRange.Select
            'Place cursor at the end of the Selection, this to avoid selecting the footnote reference
        Selection.Collapse (wdCollapseEnd)
        
        'Replace Bold
        Selection.Find.ClearFormatting
        Selection.Find.Font.Bold = True
        Selection.Find.Replacement.ClearFormatting
        With Selection.Find
            .Text = ""
            .Replacement.Text = "<B>^&<W0>"
            .Forward = True
            .Wrap = wdFindContinue
            .Format = True
            .MatchCase = False
            .MatchWholeWord = False
            .MatchWildcards = False
            .MatchSoundsLike = False
            .MatchAllWordForms = False
        End With
        Selection.Find.Execute Replace:=wdReplaceAll
        
        'Replace Italic
        Selection.Find.ClearFormatting
        Selection.Find.Font.Italic = True
        Selection.Find.Replacement.ClearFormatting
        With Selection.Find
            .Text = ""
            .Replacement.Text = "<I>^&<I*>"
            .Forward = True
            .Wrap = wdFindContinue
            .Format = True
            .MatchCase = False
            .MatchWholeWord = False
            .MatchWildcards = False
            .MatchSoundsLike = False
            .MatchAllWordForms = False
        End With
        Selection.Find.Execute Replace:=wdReplaceAll
        
        'Replace Superscript
        Selection.Find.ClearFormatting
        Selection.Find.Font.Superscript = True
        Selection.Find.Replacement.ClearFormatting
        With Selection.Find
            .Text = ""
            .Replacement.Text = "<^^>^&<^^*>"
            .Forward = True
            .Wrap = wdFindContinue
            .Format = True
            .MatchCase = False
            .MatchWholeWord = False
            .MatchWildcards = False
            .MatchSoundsLike = False
            .MatchAllWordForms = False
        End With
        Selection.Find.Execute Replace:=wdReplaceAll
        
        'Replace Subscript
        Selection.Find.ClearFormatting
        Selection.Find.Font.Subscript = True
        Selection.Find.Replacement.ClearFormatting
        With Selection.Find
            .Text = ""
            .Replacement.Text = "<V>^&<^^*>"
            .Forward = True
            .Wrap = wdFindContinue
            .Format = True
            .MatchCase = False
            .MatchWholeWord = False
            .MatchWildcards = False
            .MatchSoundsLike = False
            .MatchAllWordForms = False
        End With
        Selection.Find.Execute Replace:=wdReplaceAll

        'Simplifies the codes
        ReplaceWith "<W0><B>", "", 0
        ReplaceWith "<B><W0>", "", 0
        ReplaceWith "<B>^p<W0>", "", 0
        ReplaceWith "<B>^p", "^p<B>", 0
        ReplaceWith "^p<W0>", "<W0>^p", 0
        ReplaceWith "<I*><I>", "", 0
        ReplaceWith "<I>^p<I*>", "", 0
        ReplaceWith "<I><I*>", "", 0
        ReplaceWith "^p<B>@", "^p@", 0
        ReplaceWith "^p<I>@", "^p@", 0
        ReplaceWith "^p<I*>", "<I*>^p", 0
        ReplaceWith "^p<B*>", "<B*>^p", 0
        ReplaceWith "<$F<I*>", "<I*><$F", 0
        ReplaceWith "<$N<I*>", "<I*><$N", 0
        ReplaceWith "<$F<W0>", "<W0><$F", 0
        ReplaceWith "<$N<W0>", "<W0><$N", 0
        ReplaceWith "^s", "<|>", 0
        ReplaceWith "^l", "<R>", 0
        Selection.WholeStory
        Selection.Font.Reset
        Selection.Collapse
    Next Plage
    ActiveDocument.Styles("Footnote Reference").BaseStyle = _
        "Default Paragraph Font"
    With ActiveDocument.Styles("Footnote Reference").Font
        .Superscript = True
        .Subscript = False
    End With
    Selection.Style = ActiveDocument.Styles("Footnote Reference")

        
    For Each UneNote In ActiveDocument.Footnotes
        fnumro = UneNote.Index
        ActiveDocument.Footnotes(fnumro).Reference.Font.Superscript = True
    Next UneNote
    
    If ActiveWindow.ActivePane.View.Type = wdPrintView Or ActiveWindow. _
        ActivePane.View.Type = wdWebView Or ActiveWindow.ActivePane.View.Type = _
        wdPrintPreview Then
        ActiveWindow.View.SeekView = wdSeekMainDocument
    Else
        I = ActiveWindow.Panes.Count
        If I > 1 Then ActiveWindow.Panes(2).Close
    End If

End Sub
Sub AllAnsi()
    Dim UneFonte As Font
    ActiveWindow.Panes(1).Activate
    ActiveWindow.ActivePane.View.Type = wdNormalView
    Selection.HomeKey Unit:=wdStory
    ActiveDocument.Paragraphs.Format.Reset
    
    RemoveFonts 'Call RemoveFonts subroutine
    Selection.HomeKey Unit:=wdStory

    'Remove unwanted codes around footnotes
    'Selection.Find.Execute Replace:=wdReplaceAll
    Selection.Find.ClearFormatting
    With Selection.Find
       .Text = "<B><$F<B*>"
       .Replacement.Text = "<$F"
    End With
    Selection.Find.Execute Replace:=wdReplaceAll
 
    
End Sub
Public Sub ReplaceWith(ceci As String, cela As String, Drapeau As Long)
    Selection.Find.ClearFormatting
    Selection.Find.Replacement.ClearFormatting
    With Selection.Find
            .Text = ceci 'Ceci means This
            .Replacement.Text = cela 'Cela means That  So this reads: Replace This with That
            .Wrap = wdFindContinue
            .MatchCase = True
            Select Case Drapeau
            Case Is = 0 'No formating
                .MatchWildcards = False
                .MatchWholeWord = False
                Do While .Execute
                    .Execute Replace:=wdReplaceAll
                    Loop
            Case Is = 1 'Search whole word
                .MatchWildcards = False
                .MatchWholeWord = True
                Do While .Execute
                    .Execute Replace:=wdReplaceAll
                Loop
            Case Is = 2 'Remplacement with Wildcards
                .MatchWholeWord = False
                .MatchWildcards = True
                .Execute Replace:=wdReplaceAll
            Case Is = 3 'Remplacement with Superscript
                .MatchWholeWord = False
                .MatchWildcards = False
                .Replacement.Font.Superscript = True
                .Execute Replace:=wdReplaceAll
            Case Is = 4 'Simple search
                .MatchWholeWord = False
                .MatchWildcards = False
                .Execute Replace:=wdReplaceAll
            End Select
     End With
     Selection.Collapse
End Sub
Sub ReplaceNumbers()
    '////////////////////
    'Places a hard space after numbers
    ReplaceWith "1 ", "1^s", 0
    ReplaceWith "2 ", "2^s", 0
    ReplaceWith "3 ", "3^s", 0
    ReplaceWith "4 ", "4^s", 0
    ReplaceWith "5 ", "5^s", 0
    ReplaceWith "6 ", "6^s", 0
    ReplaceWith "7 ", "7^s", 0
    ReplaceWith "8 ", "8^s", 0
    ReplaceWith "9 ", "9^s", 0
    ReplaceWith "0 ", "0^s", 0
End Sub
Public Sub DoubleReturns()
    'Removes any double returns, also tabs and returns occurrences
    ReplaceWith "^m", "^p", 0
    ReplaceWith "^b", "^p", 0
    ReplaceWith "[^9]{1,}", "^t", 2
    ReplaceWith "[^32]{1,}", " ", 2
    ReplaceWith "[^32][^13]{1,}", "^p", 2
    ReplaceWith "^p ", "^p", 0
    ReplaceWith "^p^t", "^p", 0
    ReplaceWith "^t^p", "^p", 0
    ReplaceWith "[^13]{1,}", "^p", 2
End Sub
Sub Remplacer_OE()
    'this is for French purpose, you might want to disable this section
    ReplaceWith "coeur", "cur", 0
    ReplaceWith "Coeur", "Cur", 0
    ReplaceWith "soeur", "sur", 0
    ReplaceWith "Soeur", "Sur", 0
    ReplaceWith "moeur", "mur", 0
    ReplaceWith "Moeur", "Mur", 0
    ReplaceWith "oeuf", "uf", 0
    ReplaceWith "Oeuf", "uf", 0
    ReplaceWith "Voeu", "Vu", 0
    ReplaceWith "voeu", "vu", 0
    ReplaceWith "oeuvr", "uvr", 0
    ReplaceWith "Oeuvr", "uvr", 0
    ReplaceWith "Oeil", "il", 0
    ReplaceWith "oeil", "il", 0
End Sub
Sub Remplacer_Espaces()
    'this cleans any uneeded spaces
    ReplaceWith "  ", " ", 0
    ReplaceWith " :", ":", 0
    ReplaceWith " ;", ";", 0
    ReplaceWith " !", "!", 0
    ReplaceWith " ?", "?", 0
    ReplaceWith " ,", ",", 0
    ReplaceWith " .", ".", 0
    ReplaceWith "p. ", "p.^s", 0
    ReplaceWith " ", "", 0
    ReplaceWith " ", "", 0
End Sub
Sub PutSuperscript()
    'You might want to put your own search here.
    'It's for French, here.
    ReplaceWith "Mgr", "M*gr*", 1
        'Le drapeau 3 met en exposant
    ReplaceWith "*gr*", "gr", 3
    ReplaceWith "Dr", "D*r*", 1
    ReplaceWith "Dr.", "D*r*", 1
    ReplaceWith "*r*", "r", 3
    ReplaceWith "Mlle", "M*lle*", 1
    ReplaceWith "*lle*", "lle", 3
    ReplaceWith "Mme", "M*me*", 1
    ReplaceWith "*me*", "me", 3
    ReplaceWith "1er", "1*er*", 1
    ReplaceWith "*er*", "er", 3
End Sub
Sub ConversionEndNotesForVentura()

'Convert Endnotes into Ventura codes

Dim UneNote As Endnote, fnote As String, fnumero As Long, I As Long
ActiveWindow.Panes(1).Activate
ActiveWindow.ActivePane.View.Type = wdNormalView
Selection.HomeKey Unit:=wdStory
I = ActiveDocument.Endnotes.Count
If I = 0 Then
    MsgBox "No Endnotes in this document!"
    Exit Sub
End If
For Each UneNote In ActiveDocument.Endnotes
    fnumero = UneNote.Index
    Selection.GoTo What:=wdGoToEndnote, Count:=fnumero
    Selection.Text = "<$N>"
    Selection.Collapse wdCollapseEnd
    Selection.MoveLeft
    Selection.FormattedText = UneNote.Range.FormattedText
    ActiveDocument.Endnotes(fnumero).Delete
Next UneNote

End Sub
Sub ConversionFootNotesForVentura()
Attribute ConversionFootNotesForVentura.VB_Description = "Macro recorded mercredi, 11 juillet, 2001 by Guy"
Attribute ConversionFootNotesForVentura.VB_ProcData.VB_Invoke_Func = "Normal.NewMacros.FFi"

'Convert Footnotes into Ventura codes

Dim UneNote As Footnote, fnote As String, fnumero As Long, I As Long
ActiveWindow.Panes(1).Activate
ActiveWindow.ActivePane.View.Type = wdNormalView
Selection.HomeKey Unit:=wdStory
I = ActiveDocument.Footnotes.Count
If I = 0 Then
    MsgBox "No footnotes in this document!"
    Exit Sub
End If
For Each UneNote In ActiveDocument.Footnotes
    fnumero = UneNote.Index
    Selection.GoTo What:=wdGoToFootnote, Count:=fnumero
    Selection.Text = "<$F>"
    Selection.Collapse wdCollapseEnd
    Selection.MoveLeft
    Selection.FormattedText = UneNote.Range.FormattedText
    ActiveDocument.Footnotes(fnumero).Delete
Next UneNote

End Sub
Sub ConversionIndexForVentura()
Attribute ConversionIndexForVentura.VB_Description = "Macro recorded lundi, 23 juillet, 2001 by Guy"
Attribute ConversionIndexForVentura.VB_ProcData.VB_Invoke_Func = "Normal.NewMacros.Macro1"
'
' CodesIndexVentura Macro
' Macro recorded lundi, 23 juillet, 2001 by Guy
'

Dim afield As Field, fcode As String, Quoi As Long, Plage As Range, nombre As Long
For Each Plage In ActiveDocument.StoryRanges
    Quoi = Plage.StoryType
    Set MyRange = ActiveDocument.StoryRanges(Quoi)
        'Check if any
        nombre = MyRange.Fields.Count
        If nombre = 0 Then
            MsgBox "Aucun index dans ce document"
            Exit Sub
        End If
            
         For Each afield In MyRange.Fields
            If afield.Type = wdFieldIndexEntry Then
                afield.Select
                fcode = Mid(afield.Code, InStr(afield.Code, Chr(34)) + 1)
                fcode = Left(fcode, InStr(fcode, Chr(34)) - 1)
                If Selection.Font.Italic = True Then
                    fcode = "<$I[]<MI>" & fcode & "<WOI*>>"
                    Selection.Font.Italic = False
                Else
                    fcode = "<$I" & fcode & ">"
                End If
                Selection.Font.Bold = False
                Selection.Text = fcode
            End If
        Next afield
Next Plage

End Sub

Sub ConvertStyleIntoVentura()
        'Place le nom du style au dbut de chaque paragraphe.
    NombreParas = ActiveDocument.Paragraphs.Count
    For I = 1 To NombreParas
       With ActiveDocument.Paragraphs(I).Range
          Texte$ = .Style
          Select Case Texte$
          Case "Normal", "Normal (Web)"
            Texte$ = "Body Text"
          End Select
          .InsertBefore "@" & Texte$ & " = "
       End With
    Next I

    'Si c'est dj cod Ventura, s'assure qu'il n'y a pas double emploi de tags
    ReplaceWith "@Body Text 2 = ", "@Body Text = ", 0
    ReplaceWith "@Body Text = @", "@", 0
    ReplaceWith "^p<B>@", "^p@", 0
    ReplaceWith "^p<I>@", "^p@", 0
   
End Sub
